.include "m32def.inc"     // Includem fisirul 

; definirea unei constante
.equ const = 1020

; redefinirea registrilor
 .def tmpL  = r16
 .def tmpH  = r17
 .def aL 	= r18
 .def aH 	= r19

 

.dseg	; segmentul de date
.org 0x60				; ii indicam compilatorului originea
memVar: .BYTE 1		; rezervam 1 Byte



.cseg	; segmentul de cod 
.org	0x0000
	rjmp	Reset	; Salt neconditionat

.org	INT0addr	; External Interrupt0 Vector Address
	reti
.org	INT1addr	; External Interrupt1 Vector Address
	reti
.org	INT2addr	; External Interrupt2 Vector Address
	reti
.org	OC2addr	    ; Output Compare2 Interrupt Vector Address
	reti 
.org	OVF2addr	; Overflow2 Interrupt Vector Address
	reti
.org	ICP1addr	; Input Capture1 Interrupt Vector Address
	reti
.org	OC1Aaddr	; Output Compare1A Interrupt Vector Address
	reti
.org	OC1Baddr	; Output Compare1B Interrupt Vector Address
	reti
.org	OVF1addr	; Overflow1 Interrupt Vector Address
	reti
.org	OC0addr	    ; Output Compare0 Interrupt Vector Address
	reti
.org	OVF0addr	; Overflow0 Interrupt Vector Address
	reti
.org	SPIaddr	     ; SPI Interrupt Vector Address
	reti
.org	URXCaddr	; USART Receive Complete Interrupt Vector Address
	reti
.org	UDREaddr	; USART Data Register Empty Interrupt Vector Address
	reti
.org	UTXCaddr	; USART Transmit Complete Interrupt Vector Address
	reti
.org	ADCCaddr	; ADC Interrupt Vector Address
	reti
.org	ERDYaddr	; EEPROM Interrupt Vector Address
	reti
.org	ACIaddr 	; Analog Comparator Interrupt Vector Address
	reti
.org    TWIaddr   ; Irq. vector address for Two-Wire Interface
	reti
.org	SPMRaddr	; Store Program Memory Ready Interrupt Vector Address
	reti


; Programul principal
//--------------------------------------------------------------	 
Reset:
	// Initilizam StackPointer - la ultima adresa de memorie RAM	 
     ldi tmpL, Low(RAMEND) 	; initializam stiva
	 out SPL, tmpL
	 ldi tmpH, High(RAMEND) 
	 out SPH, tmpH

 	// Initializam periferia de care avem nevoie : Porturi, timere, contr. de intreruperi.....

	 clr tmpL			;resetam tmpl
	 ser tmpH			; Load 0xFF

	 out DDRB, tmpL		; Setam ca intrare PORTB si PORTD
	 out DDRD, tmpL

	 out DDRC, tmpH		; PortC and PortA  as output
	 out DDRA, tmpH

	 out PORTD, tmpH	; Setam PORTD ca Intrare cu rezintele PullUp

Main:
	ldi tmpL, 10		; Doar pentru depanare criem ceva in memorie
	sts memVar, tmpL


	lds aL, memVar
	ldi tmpL, 3
	muls aL, tmpL	;M[0x60] * 3

	in tmpL, PINB	; Read Data from PINB (inputs of PortB)
	clr tmpH
	sbrc tmpL, 7	; verificam BIT7 
	ser tmpH		


	sub tmpL, R0	; scadem PB- (M[0x60]*3)
	sbc tmpH, R1


	out PORTA, tmpL
	out PORTC, tmpH
	RJMP Main


